<?php
/***************************************************************************
 *   Copyright (C) 2005-2006 Artur Wiebe                                   *
 *   wibix@gmx.de                                                          *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

// FIXME
error_reporting(E_ALL);


if(file_exists(INFUSIONS."aw_music_db/locale/".$settings['locale'].".php")) {
	include(INFUSIONS."aw_music_db/locale/".$settings['locale'].".php");
} else {
	include(INFUSIONS."aw_music_db/locale/German.php");
}


define("AW_ALBUMS",		DB_PREFIX."aw_music_albums");
define("AW_CATS",		DB_PREFIX."aw_music_cats");
define("AW_ARTISTS",		DB_PREFIX."aw_music_artists");
define("AW_LABELS",		DB_PREFIX."aw_music_labels");
define("AW_SONGS",		DB_PREFIX."aw_music_songs");
define("AW_SALES",		DB_PREFIX."aw_music_sales");
define("AW_SETTINGS",		DB_PREFIX."aw_music_settings");
define("AW_IMAGES",		INFUSIONS."aw_music_db/covers/");
define("AW_IMAGE_MIME",		"image/jpeg");
define("AW_IMAGE_EMPTY",	"empty.gif");


$aw_settings = dbarray(dbquery("SELECT * FROM ".AW_SETTINGS." LIMIT 1"));
if(!$aw_settings) {
	$aw_settings['edit_group']	= 103;
	$aw_settings['per_page']	= 2;
	$aw_settings['file_size']	= 100;	// in kb
}
define("iAW_EDIT",	(iSUPERADMIN || checkgroup($aw_settings['edit_group'])));
define("AW_PER_PAGE",	(isset($aw_settings['per_page']) ? $aw_settings['per_page'] : 2));
define("AW_IMAGE_SIZE",	$aw_settings['file_size']);


/*
 * Format..: "$key" => "$value",
 * Desc....: $key: One unique char.
 *           $value: Whatever you like.
 *
 * !!! DO NOT USE "0" AS $key !!!
 */
$g_formats = array(
	"1"	=> "CD1",
	"2"	=> "CD2",
	"M"	=> "CDMAXI",
	"V"	=> "Vinyl",
	"D"	=> "DVD",
);

/*
 * Desc....: Resulting filename: AW_IMAGES/$key_$albumid.jpg
 * Some $key names may cause problems in other parts of the infusion! If so,
 * use cryptical names like "aw_my_front" - but no too long.
 * NOTE: you may also add locale strings. Format err_$key.
 */
$g_covers = array(
	"front"	=> $locale['front'],
	"back"	=> $locale['back'],
	"inlay"	=> $locale['inlay'],
);


?>
<script type="text/javascript">
function select_artist(file, artist_id) {
	document.location.href=file+'?artist_id='+artist_id;
}

function confirm_delete(frm) {
//	return true;
	return confirm("<?php echo $locale['conf_del']; ?>");
}

function do_popup(id, img) {
	wnd = window.open("popup.php?id="+id+"&img="+img, "FIXME: caption",
		"width=640,height=480");
	wnd.focus();
	return false;
}
</script>
<?php


function aw_msg($is_ok, $err_msg="") {
	global $locale;
	openside("");
	echo "<div align='center'><b>"
		.($is_ok ? "<font color='green'>".$locale['ok']."</font>"
			: "<font color='red'>".$locale['err']."</font>")
		."</b><br/>$err_msg</div>";
	closeside();
}

function aw_upload_file($type, $new_id) {
	if($_FILES[$type]['size']!=0 &&
		(!is_uploaded_file($_FILES[$type]['tmp_name'])
		|| $_FILES[$type]['size'] > AW_IMAGE_SIZE*1024
		|| $_FILES[$type]['type'] != AW_IMAGE_MIME
		|| !copy($_FILES[$type]['tmp_name'],
			AW_IMAGES.$type."_$new_id.jpg")
		|| !chmod(AW_IMAGES.$type."_$new_id.jpg", 0666))) {
		return false;
	}
	return true;
}


function show_artists_form($artist_id)
{
	global $locale;

	$query_id = dbquery("SELECT * FROM ".AW_ARTISTS
		." ORDER by artist_name ASC");
	if(!$query_id || dbrows($query_id)==0) {
		return NULL;
	}

	$artists = "";
	while($row = dbarray($query_id)) {
		$id = $row['artist_id'];
		if(is_null($artist_id)) {
			$artist_id = $id;
		}
		$artists .= "<option value='$id' "
			.($artist_id==$id ? ' selected' : '').">"
			.$row['artist_name']."</option>";
	}

	echo "<form method='get' action='".FUSION_SELF."'>"
		."<select class='textbox'"
			." onChange='select_artist(\"".FUSION_SELF."\","
			."this.options[this.selectedIndex].value);'>"
			."$artists</select>"
		."</form>";
	return $artist_id;
}

function show_albums_list($artist_id, $album_id) {
	global $locale;

	if(is_null($artist_id)) {
		return;
	}

	$query_id = dbquery("SELECT album_id, album_title"
		." FROM ".AW_ALBUMS
		." WHERE album_artist='$artist_id'");
	if($query_id) {
		$href_a = "albums.php?artist_id=$artist_id&album_id";
		$href_s = "songs.php?artist_id=$artist_id&album_id";
		$href_d = "albums.php?artist_id=$artist_id&delete=yes&album_id";
		echo "<table class='tbl-border' cellspacing='1'"
			." align='center'>\n";
		while($row = dbarray($query_id)) {
			$id = $row['album_id'];
			$title = $row['album_title'];
			if(!is_null($album_id) && $id==$album_id) {
				$title = "<b>$title</b>";
			}
			echo "<tr>"
				."<td class='tbl2'>$title</td>"
				."<td class='tbl1'>"
					."<a href='$href_a=$id'>"
					.$locale['edit']."</a>"
					." - <a href='$href_s=$id'>"
					.$locale['edit_songs']."</a>"
					." - <a onClick='return confirm_delete();' href='$href_d=$id'>"
					.$locale['del']."</a></td>\n";
		}
		echo "</table>";
	}
}


function select_album($artist_id, $album_id) {
	global $locale;

	echo "<div align='center'>";
	$artist_id = show_artists_form($artist_id);
	if(!is_null($artist_id)) {
		echo "<a href='".FUSION_SELF."?artist_id=$artist_id'>"
			.$locale['new']."</a>";
	}
	echo "</div>";

	show_albums_list($artist_id, $album_id);
	return $artist_id;
}

function show_album($album) {
	$id = $album['album_id'];
	$front_img = AW_IMAGES."front_$id.jpg";
	$back_img = AW_IMAGES."back_$id.jpg";

	if(file_exists($front_img)) {
		$front_img = "<a href='' onClick='return do_popup($id,\"front\");'>"
			."<img src='$front_img' height='120' width='120' border='0'>"
			."</a>";
	} else {
		$front_img = "<img src='".AW_IMAGE_EMPTY."'>";
	}

	if(file_exists($back_img)) {
		$back_img = "<a href='' onClick='return do_popup($id,\"back\");'>"
			."<img src='$back_img' height='120' width='120' border='0'>"
			."</a>";
	} else {
		$back_img = "<img src='".AW_IMAGE_EMPTY."'>";
	}

	// get all songs
	$query_id = dbquery("SELECT song_on_medium, song_order, song_title"
		.", song_len, song_id"
		." FROM ".AW_SONGS
		." WHERE song_album='$id'"
		." ORDER BY song_on_medium,song_order ASC");
	unset($all_songs);
	if($query_id) {
		echo "<ul>";
		while($song = dbarray($query_id)) {
			$song['song_title'] ="<a href='show_album.php?album_id="
				.$id."&song_id=".$song['song_id']."'>"
				.stripslashes($song['song_title'])."</a>";
			$all_songs[] = $song;
		}
		echo "</ul>";
	}

	render_album_with_songs($album, $front_img, $back_img, $all_songs);
}


function show_admin_menu() {
	global $locale;

	$hrefs = array(
		$locale['cats']		=>	"cats.php",
		$locale['labels']	=>	"labels.php",
		$locale['sales']	=>	"sales.php",
		$locale['artists']	=>	"artists.php",
		$locale['albums']	=>	"albums.php",
		$locale['songs']	=>	"songs.php",
		$locale['settings']	=>	"settings.php",
	);
	$w = intval(100 / count($hrefs));

	echo "<table width='100%' cellspacing='1' class='tbl-border'>\n<tr>\n";
	foreach($hrefs as $title => $file) {
		$c = (FUSION_SELF==$file ? 'tbl2' : 'tbl1');
		echo "<td class='$c' width='$w%' align='center'>"
			."<a href='$file'>$title</a></td>\n";
	}
	echo "</tr></table><div style='margin-bottom:5px;'></div>\n";
}

?>
